# wxArchiveClassFactory Class Reference
[Archive support, Streams]

`#include <wx/archive.h>`

Inheritance diagram for wxArchiveClassFactory:
[legend]

## Detailed Description

Allows the creation of streams to handle archive formats such as zip and tar.

For example, given a filename you can search for a factory that will handle it and create a stream to read it:

            factory = wxArchiveClassFactory::Find(filename, wxSTREAM_FILEEXT);
            if (factory)
                stream = factory->NewStream(new wxFFileInputStream(filename));

wxArchiveClassFactory::Find can also search for a factory by MIME type or wxFileSystem protocol.

The available factories can be enumerated using wxArchiveClassFactory::GetFirst() and wxArchiveClassFactory::GetNext().

##

Library: wxBase

Category: Archive support, Streams

See also:
  Archive Formats, Generic Archive Programming, wxArchiveEntry, wxArchiveInputStream, wxArchiveOutputStream, wxFilterClassFactory

const wxArchiveClassFactory * | GetNext () const
| GetFirst and GetNext can be used to enumerate the available factories.
static const wxArchiveClassFactory * | GetFirst ()
| GetFirst and GetNext can be used to enumerate the available factories.
## Public Member Functions
bool | CanHandle (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL) const
| Returns true if this factory can handle the given protocol, MIME type or file extension.
wxMBConv & | GetConv () const
| Returns the wxMBConv object that the created streams will use when translating meta-data.
void | SetConv (wxMBConv &conv)
| Sets the wxMBConv object that the created streams will use when translating meta-data.
virtual wxString | GetInternalName (const wxString &name, wxPathFormat format=wxPATH_NATIVE) const =0
| Calls the static GetInternalName() function for the archive entry type, for example wxZipEntry::GetInternalName.
wxString | GetProtocol () const
| Returns the wxFileSystem protocol supported by this factory.
virtual const wxChar ** | GetProtocols (wxStreamProtocolType type=wxSTREAM_PROTOCOL) const =0
| Returns the protocols, MIME types or file extensions supported by this factory, as an array of null terminated strings.
wxArchiveEntry * | NewEntry () const
| Create a new wxArchiveEntry object of the appropriate type.
void | PushFront ()
| Adds this class factory to the list returned by GetFirst() or GetNext().
void | Remove ()
| Removes this class factory from the list returned by GetFirst() and GetNext().
wxArchiveInputStream * | NewStream (wxInputStream &stream) const
| Create a new input or output stream to read or write an archive.
wxArchiveOutputStream * | NewStream (wxOutputStream &stream) const
| Create a new input or output stream to read or write an archive.
wxArchiveInputStream * | NewStream (wxInputStream *stream) const
| Create a new input or output stream to read or write an archive.
wxArchiveOutputStream * | NewStream (wxOutputStream *stream) const
| Create a new input or output stream to read or write an archive.
## Static Public Member Functions
static const wxArchiveClassFactory * | Find (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL)
| A static member that finds a factory that can handle a given protocol, MIME type or file extension.

List of all members.

## Member Function Documentation

bool wxArchiveClassFactory::CanHandle | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL` |
| ) |  |  | const

Returns true if this factory can handle the given protocol, MIME type or file extension.

When using wxSTREAM_FILEEXT for the second parameter, the first parameter can be a complete filename rather than just an extension.

static const wxArchiveClassFactory* wxArchiveClassFactory::Find | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL` |
| ) |  |  | `[static]`

A static member that finds a factory that can handle a given protocol, MIME type or file extension.

Returns a pointer to the class factory if found, or NULL otherwise. It does not give away ownership of the factory.

When using wxSTREAM_FILEEXT for the second parameter, the first parameter can be a complete filename rather than just an extension.

wxMBConv& wxArchiveClassFactory::GetConv | ( |  | ) | const

Returns the wxMBConv object that the created streams will use when translating meta-data.

The initial default, set by the constructor, is wxConvLocal.

static const wxArchiveClassFactory* wxArchiveClassFactory::GetFirst | ( |  | ) | `[static]`

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

            wxString list;
            const wxArchiveClassFactory *factory = wxArchiveClassFactory::GetFirst();

            while (factory) {
                list << factory->GetProtocol() << wxT("\n");
                factory = factory->GetNext();
            }

GetFirst() and GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

virtual wxString wxArchiveClassFactory::GetInternalName | ( | const wxString & | name,
|  | wxPathFormat | format = `wxPATH_NATIVE` |
| ) |  |  | const`[pure virtual]`

Calls the static GetInternalName() function for the archive entry type, for example wxZipEntry::GetInternalName.

const wxArchiveClassFactory* wxArchiveClassFactory::GetNext | ( |  | ) | const

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

            wxString list;
            const wxArchiveClassFactory *factory = wxArchiveClassFactory::GetFirst();

            while (factory) {
                list << factory->GetProtocol() << wxT("\n");
                factory = factory->GetNext();
            }

GetFirst() and GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

wxString wxArchiveClassFactory::GetProtocol | ( |  | ) | const

Returns the wxFileSystem protocol supported by this factory.

Equivalent to

     wxString(*GetProtocols())

.

virtual const wxChar** wxArchiveClassFactory::GetProtocols | ( | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL` | ) | const`[pure virtual]`

Returns the protocols, MIME types or file extensions supported by this factory, as an array of null terminated strings.

It does not give away ownership of the array or strings. For example, to list the file extensions a factory supports:

            wxString list;
            const wxChar *const *p;

            for (p = factory->GetProtocols(wxSTREAM_FILEEXT); *p; p++)
                list << *p << wxT("\n");

wxArchiveEntry* wxArchiveClassFactory::NewEntry | ( |  | ) | const

Create a new wxArchiveEntry object of the appropriate type.

wxArchiveOutputStream* wxArchiveClassFactory::NewStream | ( | wxOutputStream * | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

wxArchiveInputStream* wxArchiveClassFactory::NewStream | ( | wxInputStream * | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

wxArchiveOutputStream* wxArchiveClassFactory::NewStream | ( | wxOutputStream & | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

wxArchiveInputStream* wxArchiveClassFactory::NewStream | ( | wxInputStream & | stream | ) | const

Create a new input or output stream to read or write an archive.

If the parent stream is passed as a pointer then the new archive stream takes ownership of it. If it is passed by reference then it does not.

void wxArchiveClassFactory::PushFront | ( |  | ) |

Adds this class factory to the list returned by GetFirst() or GetNext().

It is not necessary to do this to use the archive streams. It is usually used when implementing streams, typically the implementation will add a static instance of its factory class.

It can also be used to change the order of a factory already in the list, bringing it to the front. This isn't a thread safe operation so can't be done when other threads are running that will be using the list. The list does not take ownership of the factory.

void wxArchiveClassFactory::Remove | ( |  | ) |

Removes this class factory from the list returned by GetFirst() and GetNext().

Removing from the list isn't a thread safe operation so can't be done when other threads are running that will be using the list. The list does not own the factories, so removing a factory does not delete it.

void wxArchiveClassFactory::SetConv | ( | wxMBConv & | conv | ) |

Sets the wxMBConv object that the created streams will use when translating meta-data.

|  | [ top ]